#!/usr/bin/env python
# -*- coding: utf-8 -*-

# CAVEAT UTILITOR
#
# This file was automatically generated by TatSu.
#
#    https://pypi.python.org/pypi/tatsu/
#
# Any changes you make to it will be overwritten the next time
# the file is generated.


from __future__ import print_function, division, absolute_import, unicode_literals

import sys

from tatsu.buffering import Buffer
from tatsu.parsing import Parser
from tatsu.parsing import tatsumasu
from tatsu.util import re, generic_main  # noqa


KEYWORDS = {}  # type: ignore


class CompositeModelExpressionBuffer(Buffer):
    def __init__(
        self,
        text,
        whitespace=None,
        nameguard=None,
        comments_re=None,
        eol_comments_re=None,
        ignorecase=None,
        namechars='',
        **kwargs
    ):
        super(CompositeModelExpressionBuffer, self).__init__(
            text,
            whitespace=whitespace,
            nameguard=nameguard,
            comments_re=comments_re,
            eol_comments_re=eol_comments_re,
            ignorecase=ignorecase,
            namechars=namechars,
            **kwargs
        )


class CompositeModelExpressionParser(Parser):
    def __init__(
        self,
        whitespace=None,
        nameguard=None,
        comments_re=None,
        eol_comments_re=None,
        ignorecase=None,
        left_recursion=True,
        parseinfo=True,
        keywords=None,
        namechars='',
        buffer_class=CompositeModelExpressionBuffer,
        **kwargs
    ):
        if keywords is None:
            keywords = KEYWORDS
        super(CompositeModelExpressionParser, self).__init__(
            whitespace=whitespace,
            nameguard=nameguard,
            comments_re=comments_re,
            eol_comments_re=eol_comments_re,
            ignorecase=ignorecase,
            left_recursion=left_recursion,
            parseinfo=parseinfo,
            keywords=keywords,
            namechars=namechars,
            buffer_class=buffer_class,
            **kwargs
        )

    @tatsumasu()
    def _result_(self):  # noqa
        self._expr_()

    @tatsumasu()
    def _expr_(self):  # noqa
        with self._choice():
            with self._option():
                self._term_()
                with self._group():
                    with self._choice():
                        with self._option():
                            self._token('+')
                        with self._option():
                            self._token('-')
                        self._error('no available options')
                self._expr_()
            with self._option():
                self._term_()
            self._error('no available options')

    @tatsumasu()
    def _term_(self):  # noqa
        with self._choice():
            with self._option():
                self._factor_()
                with self._group():
                    with self._choice():
                        with self._option():
                            self._token('*')
                        with self._option():
                            self._token('/')
                        self._error('no available options')
                self._term_()
            with self._option():
                self._factor_()
            self._error('no available options')

    @tatsumasu()
    def _factor_(self):  # noqa
        with self._choice():
            with self._option():
                self._token('(')
                self._expr_()
                self._token(')')
            with self._option():
                self._model_()
            self._error('no available options')

    @tatsumasu()
    def _model_(self):  # noqa
        self._model_name_()
        with self._optional():
            self._token('(')
            self._nickname_()
            self._token(')')

    @tatsumasu()
    def _model_name_(self):  # noqa
        self._pattern(r'[a-zA-Z_]\w*')

    @tatsumasu()
    def _nickname_(self):  # noqa
        self._pattern(r'[a-zA-Z_]\w*')


class CompositeModelExpressionSemantics(object):
    def result(self, ast):  # noqa
        return ast

    def expr(self, ast):  # noqa
        return ast

    def term(self, ast):  # noqa
        return ast

    def factor(self, ast):  # noqa
        return ast

    def model(self, ast):  # noqa
        return ast

    def model_name(self, ast):  # noqa
        return ast

    def nickname(self, ast):  # noqa
        return ast


def main(filename, start=None, **kwargs):
    if start is None:
        start = 'result'
    if not filename or filename == '-':
        text = sys.stdin.read()
    else:
        with open(filename) as f:
            text = f.read()
    parser = CompositeModelExpressionParser()
    return parser.parse(text, rule_name=start, filename=filename, **kwargs)


if __name__ == '__main__':
    import json
    from tatsu.util import asjson

    ast = generic_main(main, CompositeModelExpressionParser, name='CompositeModelExpression')
    print('AST:')
    print(ast)
    print()
    print('JSON:')
    print(json.dumps(asjson(ast), indent=2))
    print()
